module oc_filealgebra_mpi_mod
  use sep
  use oc_global_mod
  use oc_file_mod
  use mpi_sep
  use oc_filealgebra_mod
  implicit none
contains
  !----------------------------------------------------------------
  real(kind=db) function oc_rdp_d(t1_,t2_,maxmem) result(dp)
    !! computes the dot product of the files t1_ and t2_
    character(len=128), dimension(:), intent(in)  :: t1_,t2_
    integer,                          optional    :: maxmem
    integer                                       :: i,j,k,n, stat
    type(fileinfo)                                :: file1,  file2
    real,               dimension(:), allocatable :: rblov1, rblov2
    real(kind=db) :: dp_l

    if(present(maxmem)) then 
     dp_l= oc_rdp(t1_,t2_,maxmem)
    else  
      dp_l=oc_rdp(t1_,t2_,maxmem)
    end if
    call MPI_Reduce(dp_l,dp,1,MPI_DOUBLE_PRECISION,MPI_SUM,0,MPI_COMM_WORLD,stat)
    call MPI_bcast(dp,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,stat)

     

  end function oc_rdp_d
  !----------------------------------------------------------------
  complex(kind=db) function oc_cdp_d(t1_,t2_,maxmem) result(dp)
    !! computes the dot product of the files t1_ and t2_
    character(len=128), dimension(:), intent(in)  :: t1_,t2_
    integer,                          optional    :: maxmem
    integer                                       :: i,j,k,n, stat
    type(fileinfo)                                :: file1,  file2
    complex,            dimension(:), allocatable :: cblov1, cblov2
    complex(kind=db) :: dp_l

    if(present(maxmem)) then
      dp_l= oc_cdp(t1_,t2_,maxmem)
    else  
      dp_l=oc_cdp(t1_,t2_,maxmem)
    end if

    call MPI_Reduce(dp_l,dp,2,MPI_DOUBLE_COMPLEX,MPI_SUM,0,MPI_COMM_WORLD,stat)
    call MPI_bcast(dp,1,MPI_DOUBLE_COMPLEX,0,MPI_COMM_WORLD,stat)

  end function oc_cdp_d
end module oc_filealgebra_mpi_mod






